<template>
  <div>
    <BasicTable @register="registerTable">
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'size'"> {{ record.size }} kb </template>
        <template v-if="column.key === 'realName'">
          <router-link title="点击预览" to="" @click="handlePreview(record)">
            {{ record.realName }}
          </router-link>
        </template>
        <template v-if="column.key === 'action'">
          <TableAction
            :actions="[
              {
                auth: 'storage:record:query',
                icon: 'icon-eye|iconfont',
                tooltip: '查看',
                label: '查看',
                onClick: handleView.bind(null, record),
              },
              {
                auth: 'storage:record:edit',
                icon: 'icon-edit|iconfont',
                tooltip: '编辑',
                label: '编辑',
                onClick: handleEdit.bind(null, record),
              },
            ]"
            :dropDownActions="[
              {
                auth: 'storage:record:remove',
                icon: 'icon-delete|iconfont',
                tooltip: '删除',
                label: '删除',
                color: 'error',
                popConfirm: {
                  title: '是否确认删除',
                  placement: 'left',
                  confirm: handleDelete.bind(null, record),
                },
              },
              {
                auth: 'storage:record:query',
                icon: 'icon-cloud-download|iconfont',
                tooltip: '下载',
                label: '下载',
                onClick: handleDownload.bind(null, record),
              },
            ]"
          />
        </template>
      </template>
      <template #toolbar>
        <Button
          v-auth="['storage:record:add']"
          type="primary"
          @click="handleCreate"
          preIcon="icon-plus|iconfont"
        >
          新增
        </Button>
        <Button
          v-auth="['storage:record:remove']"
          type="primary"
          danger
          @click="handleDelete(null)"
          preIcon="icon-delete|iconfont"
        >
          批量删除
        </Button>
      </template>
    </BasicTable>
    <FormDrawer @register="registerDrawer" @success="handleSuccess" />
    <ViewDrawer @register="registerDrawerView" @success="handleSuccess" />
  </div>
</template>
<script lang="ts" setup>
  import { onBeforeMount, ref } from 'vue';
  import { Button } from '/@/components/Button';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';

  import { useMessage } from '/@/hooks/web/useMessage';
  import FormDrawer from './formDrawer.vue';
  import ViewDrawer from './viewDrawer.vue';
  import { columns, searchFormSchema } from './data';
  import { openWindow } from '/@/utils/index';

  import { storageRecordQueryPage, storageRecordRemove } from '/@/api/infra/storageRecordApi';
  import { useDrawer } from '/@/components/Drawer';
  import { getDownloadUrl, getPreviewUrl } from '/@/api/common';
  import { downloadByUrl } from '/@/utils/file/download';

  onBeforeMount(async () => {});

  const { createConfirm, createMessage } = useMessage();
  // const [registerModal, { openModal }] = useModal();
  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerDrawerView, { openDrawer: openDrawerView }] = useDrawer();

  const tableSort = ref([
    {
      field: 'create_time',
      direction: 'DESC',
    },
  ]) as any;

  const [registerTable, { reload, getSelectRowKeys, clearSelectedRowKeys }] = useTable({
    title: ' ',
    api: storageRecordQueryPage,
    rowKey: 'id',
    columns,
    showIndexColumn: true,
    rowSelection: { type: 'checkbox' },
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      baseColProps: { xs: 24, sm: 12, md: 12, lg: 8 },
      resetButtonOptions: {
        preIcon: 'icon-delete|iconfont',
      },
      submitButtonOptions: {
        preIcon: 'icon-search|iconfont',
      },
    },
    useSearchForm: true,
    bordered: true,
    actionColumn: {
      width: 200,
      title: '操作',
      dataIndex: 'action',
    },
    beforeFetch: handleBeforeFetch,
    sortFn: handleSortFn,
  });
  // 详情按钮事件
  function handleView(record: Recordable) {
    console.log(record);
    openDrawerView(true, {
      record,
    });
  }

  // 新增按钮事件
  function handleCreate() {
    openDrawer(true, {
      isUpdate: false,
    });
  }

  // 编辑按钮事件
  function handleEdit(record: Recordable) {
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  }

  // 删除按钮事件
  async function handleDelete(record: Recordable) {
    if (record) {
      await storageRecordRemove([record.id]);
      createMessage.success('删除成功！');
      await reload();
    } else {
      const keys = getSelectRowKeys();
      if (keys.length > 0) {
        createConfirm({
          content: '是否确定要删除此附件？',
          iconType: 'warning',
          onOk: async () => {
            await storageRecordRemove(keys);
            createMessage.success('删除成功！');
            await reload();
            clearSelectedRowKeys();
          },
        });
      } else {
        createMessage.warning('请选择要删除的数据');
      }
    }
  }

  /// 点击文件名下载文件
  async function handlePreview(row) {
    const preUrl = await getPreviewUrl(row.id);
    openWindow(preUrl, { target: '_blank' });
  }

  /// 点击文件名下载文件
  async function handleDownload(row) {
    const dUrl = await getDownloadUrl(row.id);
    await downloadByUrl({ url: dUrl });
  }
  // 表格点击字段排序
  function handleSortFn(sortInfo) {
    if (sortInfo?.order && sortInfo?.columnKey) {
      // 默认单列排序
      tableSort.value = [
        {
          field: sortInfo.columnKey,
          direction: sortInfo.order.replace(/(\w+)(end)/g, '$1').toUpperCase(),
        },
      ];
    }
  }

  // 表格请求之前，对参数进行处理, 添加默认 排序
  function handleBeforeFetch(params) {
    return { ...params, orders: tableSort.value };
  }

  // 弹窗回调事件
  async function handleSuccess({ isUpdate, values }) {
    console.log(isUpdate);
    console.log(values);
    await reload();
  }
</script>
